Subject: RE: loading kernel via EJTAG interface

From: Prashant Viswanathan <[email-masked]>
Date: Wed, 4 Feb 2004 16:44:24 -0800

> -----Original Message-----
> From: Nathan Field [mailto:[email-masked]]
> Sent: Wednesday, February 04, 2004 4:36 PM
> To: Shaun Savage
> Cc: Prashant Viswanathan; [email-masked]'
> Subject: Re: loading kernel via EJTAG interface
> 
> 
> > > I am trying to load a linux kernel through a EJTAG 
> device. I was told
> > > that I should modify the kernel so that it doesnt attempt 
> to use the
> > > parameters passed to it by the loader. However, I am not 
> quite sure as
> > > to what it means and what exactly one has to do. I would really
> > > appreciate any pointers/help/suggestions.
> 	One approach is to create some sort of setup script that 
> "emulates" the boot loader. I've done that for a Malta board 
> (which uses a 
> boot loader called YAMON). Basically it does something like this:
> 
> 	reset and run the board
> 	sleep for 7 seconds to let YAMON do its normal setup
> 	halt the board
> 	do all the setup that YAMON would do when it runs a program
> 
> That last step is where the magic happens. Basically I do things like
> setup various registers to point to memory regions, and then in those
> regions create arrays of pointers, which point to strings containing
> things like the "environment" that YAMON fills in for programs and
> arguments that it passes. Depending on the capabilities of 
> your debugging
> environment this can either be easy or hard. My setup is really nice,
> downloads for small kernels take about the same time as going through
> tftp, but bigger kernels with a ramdisk are actually faster to push
> through EJTAG, which is nice :)
> 
> 	nathan

Thanks for the input.

I have a bootrom (different operating system) on my device and if I just
boot up from the bootrom it would set up all the registers, controllers for
me. Also, visionProbe (which I am using to download over the EJTAG
interface) sets up all the controllers for me. 

So, can't I just load the kernel image and just start executing from
"kernel_entry"?

Prashant

---

From: [email-masked]
Date: Thu, 5 Feb 2004 08:58:43 +0100

Hi,

>So, can't I just load the kernel image and just start executing from

For testing purposes it might be feasible to hard code a command line and
environment into the kernel. I did this during test with a Lauterbach
debugger.
Of course you still have to setup SDRAM, clocks etc. before executing the
kernel.

regards
Andre